#ifndef EFL_GENERATED_EVAS_LINE_HH
#define EFL_GENERATED_EVAS_LINE_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_line.eo.h"
}

#include "evas_object.eo.hh"

namespace evas {

struct line
      : evas::object
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit line(Eo* eo)
      : evas::object(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit line(std::nullptr_t)
      : evas::object(nullptr)
   {}

   /// @brief Call the object's constructor.
   /// Should not be used with #eo_do. Only use it with #eo_do_super.
   ///
   line(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : line(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   line(line const& other)
      : evas::object(eo_ref(other._eo_ptr()))
   {}

   ~line() {}

   /// @brief Retrieves the coordinates of the end points of the given evas line object.
   /// second end point.
   ///
   /// @param x1 The X coordinate of the first point.
   /// @param y1 The Y coordinate of the first point.
   /// @param x2 The X coordinate of the second point.
   /// @param y2 The Y coordinate of the second point.
   ///
   void xy_get(Evas_Coord* x1_, Evas_Coord* y1_, Evas_Coord* x2_, Evas_Coord* y2_) const
   {
      eo_do(_eo_ptr(), ::evas_obj_line_xy_get(x1_, y1_, x2_, y2_));
   }

   /// @brief @since 1.8
   ///
   /// Sets the coordinates of the end points of the given evas line object.
   ///
   /// @param x1 The X coordinate of the first point.
   /// @param y1 The Y coordinate of the first point.
   /// @param x2 The X coordinate of the second point.
   /// @param y2 The Y coordinate of the second point.
   ///
   void xy_set(Evas_Coord x1_, Evas_Coord y1_, Evas_Coord x2_, Evas_Coord y2_) const
   {
      eo_do(_eo_ptr(), ::evas_obj_line_xy_set(x1_, y1_, x2_, y2_));
   }

   static Eo_Class const* _eo_class()
   {
      return(EVAS_LINE_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_ref(EVAS_LINE_CLASS, _p._eo_raw, eo_constructor());
   }

};
} 

template <typename T>
void evas_line_xy_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* x1_, Evas_Coord* y1_, Evas_Coord* x2_, Evas_Coord* y2_)
{
   static_cast<T*>(self->this_)->xy_get(x1_, y1_, x2_, y2_);
}

template <typename T>
void evas_line_xy_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord x1_, Evas_Coord y1_, Evas_Coord x2_, Evas_Coord y2_)
{
   static_cast<T*>(self->this_)->xy_set(x1_, y1_, x2_, y2_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< evas::line >
{
   template <typename T>
   struct type
   {
      virtual void xy_get(Evas_Coord* x1_, Evas_Coord* y1_, Evas_Coord* x2_, Evas_Coord* y2_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_obj_line_xy_get(x1_, y1_, x2_, y2_));
      }

      virtual void xy_set(Evas_Coord x1_, Evas_Coord y1_, Evas_Coord x2_, Evas_Coord y2_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_obj_line_xy_set(x1_, y1_, x2_, y2_));
      }

   };
};


template<>
struct operation_description_class_size< evas::line >
{
   static const int value = 2;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<evas::line>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::evas_line_xy_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_obj_line_xy_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::evas_line_xy_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::evas_obj_line_xy_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< evas::line >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<evas::line, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< evas::line >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<evas::line, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< evas::line>
{
   template <typename U>
   struct type
   {
      operator evas::line() const
      {
         return evas::line(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void xy_get(Evas_Coord* x1_, Evas_Coord* y1_, Evas_Coord* x2_, Evas_Coord* y2_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_obj_line_xy_get(x1_, y1_, x2_, y2_));
      }

      void xy_set(Evas_Coord x1_, Evas_Coord y1_, Evas_Coord x2_, Evas_Coord y2_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_obj_line_xy_set(x1_, y1_, x2_, y2_));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<evas::line>)
{
   return (EVAS_LINE_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_LINE_HH

